diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/lte/model/cqa-ff-mac-scheduler.cc ns-3.40/src/lte/model/cqa-ff-mac-scheduler.cc
--- ns-3.39/src/lte/model/cqa-ff-mac-scheduler.cc	2023-07-05 14:23:47.901427700 -0700
+++ ns-3.40/src/lte/model/cqa-ff-mac-scheduler.cc	2023-09-27 13:30:37.706839300 -0700
@@ -2178,7 +2109,7 @@
             break;
         }
 
-        std::map<uint16_t, std::vector<double>>::iterator itCqi = m_ueCqi.find((*it).first);
+        auto itCqi = m_ueCqi.find((*it).first);
         int cqi = 0;
         if (itCqi == m_ueCqi.end())
         {
@@ -2249,15 +2180,13 @@
         uint8_t harqId = 0;
         if (m_harqOn)
         {
-            std::map<uint16_t, uint8_t>::iterator itProcId;
-            itProcId = m_ulHarqCurrentProcessId.find(uldci.m_rnti);
+            auto itProcId = m_ulHarqCurrentProcessId.find(uldci.m_rnti);
             if (itProcId == m_ulHarqCurrentProcessId.end())
             {
                 NS_FATAL_ERROR("No info find in HARQ buffer for UE " << uldci.m_rnti);
             }
             harqId = (*itProcId).second;
-            std::map<uint16_t, UlHarqProcessesDciBuffer_t>::iterator itDci =
-                m_ulHarqProcessesDciBuffer.find(uldci.m_rnti);
+            auto itDci = m_ulHarqProcessesDciBuffer.find(uldci.m_rnti);
             if (itDci == m_ulHarqProcessesDciBuffer.end())
             {
                 NS_FATAL_ERROR("Unable to find RNTI entry in UL DCI HARQ buffer for RNTI "
@@ -2265,8 +2194,7 @@
             }
             (*itDci).second.at(harqId) = uldci;
             // Update HARQ process status (RV 0)
-            std::map<uint16_t, UlHarqProcessesStatus_t>::iterator itStat =
-                m_ulHarqProcessesStatus.find(uldci.m_rnti);
+            auto itStat = m_ulHarqProcessesStatus.find(uldci.m_rnti);
             if (itStat == m_ulHarqProcessesStatus.end())
             {
                 NS_LOG_ERROR("No info find in HARQ buffer for UE (might change eNB) "
@@ -2282,7 +2210,7 @@
                          << (uint16_t)harqId);
 
         // update TTI  UE stats
-        itStats = m_flowStatsUl.find((*it).first);
+        auto itStats = m_flowStatsUl.find((*it).first);
         if (itStats != m_flowStatsUl.end())
         {
             (*itStats).second.lastTtiBytesTransmitted = uldci.m_tbSize;
@@ -2308,7 +2236,7 @@
 
     // Update global UE stats
     // update UEs stats
-    for (itStats = m_flowStatsUl.begin(); itStats != m_flowStatsUl.end(); itStats++)
+    for (auto itStats = m_flowStatsUl.begin(); itStats != m_flowStatsUl.end(); itStats++)
     {
         (*itStats).second.totalBytesTransmitted += (*itStats).second.lastTtiBytesTransmitted;
         // update average throughput (see eq. 12.3 of Sec 12.3.1.2 of LTE – The UMTS Long Term
@@ -2345,8 +2273,6 @@
 {
     NS_LOG_FUNCTION(this);
 
-    std::map<uint16_t, uint32_t>::iterator it;
-
     for (unsigned int i = 0; i < params.m_macCeList.size(); i++)
     {
         if (params.m_macCeList.at(i).m_macCeType == MacCeListElement_s::BSR)
@@ -2367,7 +2293,7 @@
 
             uint16_t rnti = params.m_macCeList.at(i).m_rnti;
             NS_LOG_LOGIC(this << "RNTI=" << rnti << " buffer=" << buffer);
-            it = m_ceBsrRxed.find(rnti);
+            auto it = m_ceBsrRxed.find(rnti);
             if (it == m_ceBsrRxed.end())
             {
                 // create the new entry
@@ -2413,11 +2339,9 @@
     switch (params.m_ulCqi.m_type)
     {
     case UlCqi_s::PUSCH: {
-        std::map<uint16_t, std::vector<uint16_t>>::iterator itMap;
-        std::map<uint16_t, std::vector<double>>::iterator itCqi;
         NS_LOG_DEBUG(this << " Collect PUSCH CQIs of Frame no. " << (params.m_sfnSf >> 4)
                           << " subframe no. " << (0xF & params.m_sfnSf));
-        itMap = m_allocationMaps.find(params.m_sfnSf);
+        auto itMap = m_allocationMaps.find(params.m_sfnSf);
         if (itMap == m_allocationMaps.end())
         {
             return;
@@ -2426,7 +2350,7 @@
         {
             // convert from fixed point notation Sxxxxxxxxxxx.xxx to double
             double sinr = LteFfConverter::fpS11dot3toDouble(params.m_ulCqi.m_sinr.at(i));
-            itCqi = m_ueCqi.find((*itMap).second.at(i));
+            auto itCqi = m_ueCqi.find((*itMap).second.at(i));
             if (itCqi == m_ueCqi.end())
             {
                 // create a new entry
@@ -2456,8 +2380,7 @@
                 NS_LOG_DEBUG(this << " RNTI " << (*itMap).second.at(i) << " RB " << i << " SINR "
                                   << sinr);
                 // update correspondent timer
-                std::map<uint16_t, uint32_t>::iterator itTimers;
-                itTimers = m_ueCqiTimers.find((*itMap).second.at(i));
+                auto itTimers = m_ueCqiTimers.find((*itMap).second.at(i));
                 (*itTimers).second = m_cqiTimersThreshold;
             }
         }
@@ -2480,8 +2403,7 @@
                 rnti = vsp->GetRnti();
             }
         }
-        std::map<uint16_t, std::vector<double>>::iterator itCqi;
-        itCqi = m_ueCqi.find(rnti);
+        auto itCqi = m_ueCqi.find(rnti);
         if (itCqi == m_ueCqi.end())
         {
             // create a new entry
@@ -2508,8 +2430,7 @@
                                  << sinr);
             }
             // update correspondent timer
-            std::map<uint16_t, uint32_t>::iterator itTimers;
-            itTimers = m_ueCqiTimers.find(rnti);
+            auto itTimers = m_ueCqiTimers.find(rnti);
             (*itTimers).second = m_cqiTimersThreshold;
         }
     }
@@ -2529,7 +2450,7 @@
 CqaFfMacScheduler::RefreshDlCqiMaps()
 {
     // refresh DL CQI P01 Map
-    std::map<uint16_t, uint32_t>::iterator itP10 = m_p10CqiTimers.begin();
+    auto itP10 = m_p10CqiTimers.begin();
     while (itP10 != m_p10CqiTimers.end())
     {
         NS_LOG_INFO(this << " P10-CQI for user " << (*itP10).first << " is "
@@ -2537,12 +2458,12 @@
         if ((*itP10).second == 0)
         {
             // delete correspondent entries
-            std::map<uint16_t, uint8_t>::iterator itMap = m_p10CqiRxed.find((*itP10).first);
+            auto itMap = m_p10CqiRxed.find((*itP10).first);
             NS_ASSERT_MSG(itMap != m_p10CqiRxed.end(),
                           " Does not find CQI report for user " << (*itP10).first);
             NS_LOG_INFO(this << " P10-CQI expired for user " << (*itP10).first);
             m_p10CqiRxed.erase(itMap);
-            std::map<uint16_t, uint32_t>::iterator temp = itP10;
+            auto temp = itP10;
             itP10++;
             m_p10CqiTimers.erase(temp);
         }
@@ -2554,7 +2475,7 @@
     }
 
     // refresh DL CQI A30 Map
-    std::map<uint16_t, uint32_t>::iterator itA30 = m_a30CqiTimers.begin();
+    auto itA30 = m_a30CqiTimers.begin();
     while (itA30 != m_a30CqiTimers.end())
     {
         NS_LOG_INFO(this << " A30-CQI for user " << (*itA30).first << " is "
@@ -2562,12 +2483,12 @@
         if ((*itA30).second == 0)
         {
             // delete correspondent entries
-            std::map<uint16_t, SbMeasResult_s>::iterator itMap = m_a30CqiRxed.find((*itA30).first);
+            auto itMap = m_a30CqiRxed.find((*itA30).first);
             NS_ASSERT_MSG(itMap != m_a30CqiRxed.end(),
                           " Does not find CQI report for user " << (*itA30).first);
             NS_LOG_INFO(this << " A30-CQI expired for user " << (*itA30).first);
             m_a30CqiRxed.erase(itMap);
-            std::map<uint16_t, uint32_t>::iterator temp = itA30;
+            auto temp = itA30;
             itA30++;
             m_a30CqiTimers.erase(temp);
         }
@@ -2583,7 +2504,7 @@
 CqaFfMacScheduler::RefreshUlCqiMaps()
 {
     // refresh UL CQI  Map
-    std::map<uint16_t, uint32_t>::iterator itUl = m_ueCqiTimers.begin();
+    auto itUl = m_ueCqiTimers.begin();
     while (itUl != m_ueCqiTimers.end())
     {
         NS_LOG_INFO(this << " UL-CQI for user " << (*itUl).first << " is "
@@ -2591,13 +2512,13 @@
         if ((*itUl).second == 0)
         {
             // delete correspondent entries
-            std::map<uint16_t, std::vector<double>>::iterator itMap = m_ueCqi.find((*itUl).first);
+            auto itMap = m_ueCqi.find((*itUl).first);
             NS_ASSERT_MSG(itMap != m_ueCqi.end(),
                           " Does not find CQI report for user " << (*itUl).first);
             NS_LOG_INFO(this << " UL-CQI exired for user " << (*itUl).first);
             (*itMap).second.clear();
             m_ueCqi.erase(itMap);
-            std::map<uint16_t, uint32_t>::iterator temp = itUl;
+            auto temp = itUl;
             itUl++;
             m_ueCqiTimers.erase(temp);
         }
@@ -2612,9 +2533,8 @@
 void
 CqaFfMacScheduler::UpdateDlRlcBufferInfo(uint16_t rnti, uint8_t lcid, uint16_t size)
 {
-    std::map<LteFlowId_t, FfMacSchedSapProvider::SchedDlRlcBufferReqParameters>::iterator it;
     LteFlowId_t flow(rnti, lcid);
-    it = m_rlcBufferReq.find(flow);
+    auto it = m_rlcBufferReq.find(flow);
     if (it != m_rlcBufferReq.end())
     {
         NS_LOG_INFO(this << " UE " << rnti << " LC " << (uint16_t)lcid << " txqueue "
@@ -2669,7 +2589,7 @@
 CqaFfMacScheduler::UpdateUlRlcBufferInfo(uint16_t rnti, uint16_t size)
 {
     size = size - 2; // remove the minimum RLC overhead
-    std::map<uint16_t, uint32_t>::iterator it = m_ceBsrRxed.find(rnti);
+    auto it = m_ceBsrRxed.find(rnti);
     if (it != m_ceBsrRxed.end())
     {
         NS_LOG_INFO(this << " UE " << rnti << " size " << size << " BSR " << (*it).second);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/lte/model/epc-enb-application.cc ns-3.40/src/lte/model/epc-enb-application.cc
--- ns-3.39/src/lte/model/epc-enb-application.cc	2023-07-05 14:23:47.901427700 -0700
+++ ns-3.40/src/lte/model/epc-enb-application.cc	2023-09-27 13:30:37.706839300 -0700
@@ -164,9 +164,7 @@
 
     uint16_t gci = params.cellId;
     std::list<EpcS1apSapMme::ErabSwitchedInDownlinkItem> erabToBeSwitchedInDownlinkList;
-    for (std::list<EpcEnbS1SapProvider::BearerToBeSwitched>::iterator bit =
-             params.bearersToBeSwitched.begin();
-         bit != params.bearersToBeSwitched.end();
+    for (auto bit = params.bearersToBeSwitched.begin(); bit != params.bearersToBeSwitched.end();
          ++bit)
     {
         EpsFlowId_t flowId;
@@ -193,12 +191,10 @@
 EpcEnbApplication::DoUeContextRelease(uint16_t rnti)
 {
     NS_LOG_FUNCTION(this << rnti);
-    std::map<uint16_t, std::map<uint8_t, uint32_t>>::iterator rntiIt = m_rbidTeidMap.find(rnti);
+    auto rntiIt = m_rbidTeidMap.find(rnti);
     if (rntiIt != m_rbidTeidMap.end())
     {
-        for (std::map<uint8_t, uint32_t>::iterator bidIt = rntiIt->second.begin();
-             bidIt != rntiIt->second.end();
-             ++bidIt)
+        for (auto bidIt = rntiIt->second.begin(); bidIt != rntiIt->second.end(); ++bidIt)
         {
             uint32_t teid = bidIt->second;
             m_teidRbidMap.erase(teid);
@@ -218,13 +214,11 @@
     NS_LOG_FUNCTION(this);
 
     uint64_t imsi = mmeUeS1Id;
-    std::map<uint64_t, uint16_t>::iterator imsiIt = m_imsiRntiMap.find(imsi);
+    auto imsiIt = m_imsiRntiMap.find(imsi);
     NS_ASSERT_MSG(imsiIt != m_imsiRntiMap.end(), "unknown IMSI");
     uint16_t rnti = imsiIt->second;
 
-    for (std::list<EpcS1apSapEnb::ErabToBeSetupItem>::iterator erabIt = erabToBeSetupList.begin();
-         erabIt != erabToBeSetupList.end();
-         ++erabIt)
+    for (auto erabIt = erabToBeSetupList.begin(); erabIt != erabToBeSetupList.end(); ++erabIt)
     {
         // request the RRC to setup a radio bearer
         EpcEnbS1SapUser::DataRadioBearerSetupRequestParameters params;
@@ -256,7 +250,7 @@
     NS_LOG_FUNCTION(this);
 
     uint64_t imsi = mmeUeS1Id;
-    std::map<uint64_t, uint16_t>::iterator imsiIt = m_imsiRntiMap.find(imsi);
+    auto imsiIt = m_imsiRntiMap.find(imsi);
     NS_ASSERT_MSG(imsiIt != m_imsiRntiMap.end(), "unknown IMSI");
     uint16_t rnti = imsiIt->second;
     EpcEnbS1SapUser::PathSwitchRequestAcknowledgeParameters params;
@@ -283,15 +277,15 @@
     NS_ASSERT(found);
     uint16_t rnti = tag.GetRnti();
     uint8_t bid = tag.GetBid();
-    NS_LOG_LOGIC("received packet with RNTI=" << (uint32_t)rnti << ", BID=" << (uint32_t)bid);
-    std::map<uint16_t, std::map<uint8_t, uint32_t>>::iterator rntiIt = m_rbidTeidMap.find(rnti);
+    NS_LOG_INFO("Received packet with RNTI: " << rnti << ", BID: " << +bid);
+    auto rntiIt = m_rbidTeidMap.find(rnti);
     if (rntiIt == m_rbidTeidMap.end())
     {
         NS_LOG_WARN("UE context not found, discarding packet");
     }
     else
     {
-        std::map<uint8_t, uint32_t>::iterator bidIt = rntiIt->second.find(bid);
+        auto bidIt = rntiIt->second.find(bid);
         NS_ASSERT(bidIt != rntiIt->second.end());
         uint32_t teid = bidIt->second;
         m_rxLteSocketPktTrace(packet->Copy());
@@ -308,7 +302,8 @@
     GtpuHeader gtpu;
     packet->RemoveHeader(gtpu);
     uint32_t teid = gtpu.GetTeid();
-    std::map<uint32_t, EpsFlowId_t>::iterator it = m_teidRbidMap.find(teid);
+    NS_LOG_INFO("Received packet from S1-U interface with GTP TEID: " << teid);
+    auto it = m_teidRbidMap.find(teid);
     if (it == m_teidRbidMap.end())
     {
         NS_LOG_WARN("UE context at cell id " << m_cellId << " not found, discarding packet");
@@ -323,9 +318,10 @@
 void
 EpcEnbApplication::SendToLteSocket(Ptr<Packet> packet, uint16_t rnti, uint8_t bid)
 {
-    NS_LOG_FUNCTION(this << packet << rnti << (uint16_t)bid << packet->GetSize());
+    NS_LOG_FUNCTION(this << packet << rnti << bid << packet->GetSize());
     EpsBearerTag tag(rnti, bid);
     packet->AddPacketTag(tag);
+    NS_LOG_INFO("Add EpsBearerTag with RNTI " << rnti << " and bearer ID " << +bid);
     uint8_t ipType;
 
     packet->CopyData(&ipType, 1);
@@ -334,10 +330,12 @@
     int sentBytes;
     if (ipType == 0x04)
     {
+        NS_LOG_INFO("Forward packet from eNB's S1-U to LTE stack via IPv4 socket.");
         sentBytes = m_lteSocket->Send(packet);
     }
     else if (ipType == 0x06)
     {
+        NS_LOG_INFO("Forward packet from eNB's S1-U to LTE stack via IPv6 socket.");
         sentBytes = m_lteSocket6->Send(packet);
     }
     else
@@ -359,6 +357,7 @@
     gtpu.SetLength(packet->GetSize() + gtpu.GetSerializedSize() - 8);
     packet->AddHeader(gtpu);
     uint32_t flags = 0;
+    NS_LOG_INFO("Forward packet from eNB's LTE to S1-U stack with TEID: " << teid);
     m_s1uSocket->SendTo(packet, flags, InetSocketAddress(m_sgwS1uAddress, m_gtpuUdpPort));
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/lte/model/epc-mme-application.cc ns-3.40/src/lte/model/epc-mme-application.cc
--- ns-3.39/src/lte/model/epc-mme-application.cc	2023-07-05 14:23:47.905427700 -0700
+++ ns-3.40/src/lte/model/epc-mme-application.cc	2023-09-27 13:30:37.706839300 -0700
@@ -103,7 +103,7 @@
 EpcMmeApplication::AddBearer(uint64_t imsi, Ptr<EpcTft> tft, EpsBearer bearer)
 {
     NS_LOG_FUNCTION(this << imsi);
-    std::map<uint64_t, Ptr<UeInfo>>::iterator it = m_ueInfoMap.find(imsi);
+    auto it = m_ueInfoMap.find(imsi);
     NS_ASSERT_MSG(it != m_ueInfoMap.end(), "could not find any UE with IMSI " << imsi);
     NS_ASSERT_MSG(it->second->bearerCounter < 11,
                   "too many bearers already! " << it->second->bearerCounter);
@@ -124,7 +124,7 @@
                                       uint16_t gci)
 {
     NS_LOG_FUNCTION(this << mmeUeS1Id << enbUeS1Id << imsi << gci);
-    std::map<uint64_t, Ptr<UeInfo>>::iterator it = m_ueInfoMap.find(imsi);
+    auto it = m_ueInfoMap.find(imsi);
     NS_ASSERT_MSG(it != m_ueInfoMap.end(), "could not find any UE with IMSI " << imsi);
     it->second->cellId = gci;
 
@@ -139,7 +139,7 @@
     msg.SetSenderCpFteid(mmeS11Fteid); // S11 MME GTP-C F-TEID
 
     std::list<GtpcCreateSessionRequestMessage::BearerContextToBeCreated> bearerContexts;
-    for (std::list<BearerInfo>::iterator bit = it->second->bearersToBeActivated.begin();
+    for (auto bit = it->second->bearersToBeActivated.begin();
          bit != it->second->bearersToBeActivated.end();
          ++bit)
     {
@@ -180,7 +180,7 @@
 {
     NS_LOG_FUNCTION(this << mmeUeS1Id << enbUeS1Id << gci);
     uint64_t imsi = mmeUeS1Id;
-    std::map<uint64_t, Ptr<UeInfo>>::iterator it = m_ueInfoMap.find(imsi);
+    auto it = m_ueInfoMap.find(imsi);
     NS_ASSERT_MSG(it != m_ueInfoMap.end(), "could not find any UE with IMSI " << imsi);
     NS_LOG_INFO("IMSI " << imsi << " old eNB: " << it->second->cellId << ", new eNB: " << gci);
     it->second->cellId = gci;
@@ -221,7 +221,7 @@
 {
     NS_LOG_FUNCTION(this << mmeUeS1Id << enbUeS1Id);
     uint64_t imsi = mmeUeS1Id;
-    std::map<uint64_t, Ptr<UeInfo>>::iterator it = m_ueInfoMap.find(imsi);
+    auto it = m_ueInfoMap.find(imsi);
     NS_ASSERT_MSG(it != m_ueInfoMap.end(), "could not find any UE with IMSI " << imsi);
 
     GtpcDeleteBearerCommandMessage msg;
@@ -247,7 +247,7 @@
 EpcMmeApplication::RemoveBearer(Ptr<UeInfo> ueInfo, uint8_t epsBearerId)
 {
     NS_LOG_FUNCTION(this << epsBearerId);
-    std::list<BearerInfo>::iterator bit = ueInfo->bearersToBeActivated.begin();
+    auto bit = ueInfo->bearersToBeActivated.begin();
     while (bit != ueInfo->bearersToBeActivated.end())
     {
         if (bit->bearerId == epsBearerId)
@@ -296,13 +296,13 @@
     NS_LOG_FUNCTION(this << header);
     uint64_t imsi = header.GetTeid();
     NS_LOG_DEBUG("TEID/IMSI " << imsi);
-    std::map<uint64_t, Ptr<UeInfo>>::iterator it = m_ueInfoMap.find(imsi);
+    auto it = m_ueInfoMap.find(imsi);
     NS_ASSERT_MSG(it != m_ueInfoMap.end(), "could not find any UE with IMSI " << imsi);
     uint16_t cellId = it->second->cellId;
     uint16_t enbUeS1Id = it->second->enbUeS1Id;
     uint64_t mmeUeS1Id = it->second->mmeUeS1Id;
     NS_LOG_DEBUG("cellId " << cellId << " mmeUeS1Id " << mmeUeS1Id << " enbUeS1Id " << enbUeS1Id);
-    std::map<uint16_t, Ptr<EnbInfo>>::iterator jt = m_enbInfoMap.find(cellId);
+    auto jt = m_enbInfoMap.find(cellId);
     NS_ASSERT_MSG(jt != m_enbInfoMap.end(), "could not find any eNB with CellId " << cellId);
 
     GtpcCreateSessionResponseMessage msg;
@@ -337,7 +337,7 @@
 
     uint64_t imsi = header.GetTeid();
     NS_LOG_DEBUG("TEID/IMSI " << imsi);
-    std::map<uint64_t, Ptr<UeInfo>>::iterator it = m_ueInfoMap.find(imsi);
+    auto it = m_ueInfoMap.find(imsi);
     NS_ASSERT_MSG(it != m_ueInfoMap.end(), "could not find any UE with IMSI " << imsi);
     uint16_t cellId = it->second->cellId;
     uint16_t enbUeS1Id = it->second->enbUeS1Id;
@@ -345,7 +345,7 @@
     NS_LOG_DEBUG("cellId " << cellId << " mmeUeS1Id " << mmeUeS1Id << " enbUeS1Id " << enbUeS1Id);
     std::list<EpcS1apSapEnb::ErabSwitchedInUplinkItem>
         erabToBeSwitchedInUplinkList; // unused for now
-    std::map<uint16_t, Ptr<EnbInfo>>::iterator jt = m_enbInfoMap.find(cellId);
+    auto jt = m_enbInfoMap.find(cellId);
     NS_ASSERT_MSG(jt != m_enbInfoMap.end(), "could not find any eNB with CellId " << cellId);
 
     NS_LOG_DEBUG("Send PathSwitchRequestAcknowledge to eNB " << jt->second->s1apSapEnb);
@@ -361,7 +361,7 @@
     NS_LOG_FUNCTION(this << header);
     uint64_t imsi = header.GetTeid();
     NS_LOG_DEBUG("TEID/IMSI " << imsi);
-    std::map<uint64_t, Ptr<UeInfo>>::iterator it = m_ueInfoMap.find(imsi);
+    auto it = m_ueInfoMap.find(imsi);
     NS_ASSERT_MSG(it != m_ueInfoMap.end(), "could not find any UE with IMSI " << imsi);
 
     GtpcDeleteBearerRequestMessage msg;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/lte/model/epc-pgw-application.cc ns-3.40/src/lte/model/epc-pgw-application.cc
--- ns-3.39/src/lte/model/epc-pgw-application.cc	2023-07-05 14:23:47.905427700 -0700
+++ ns-3.40/src/lte/model/epc-pgw-application.cc	2023-09-27 13:30:37.706839300 -0700
@@ -58,7 +58,7 @@
 EpcPgwApplication::UeInfo::RemoveBearer(uint8_t bearerId)
 {
     NS_LOG_FUNCTION(this << (uint16_t)bearerId);
-    std::map<uint8_t, uint32_t>::iterator it = m_teidByBearerIdMap.find(bearerId);
+    auto it = m_teidByBearerIdMap.find(bearerId);
     m_tftClassifier.Delete(it->second); // delete tft
     m_teidByBearerIdMap.erase(bearerId);
 }
@@ -180,7 +180,7 @@
         NS_LOG_LOGIC("packet addressed to UE " << ueAddr);
 
         // find corresponding UeInfo address
-        std::map<Ipv4Address, Ptr<UeInfo>>::iterator it = m_ueInfoByAddrMap.find(ueAddr);
+        auto it = m_ueInfoByAddrMap.find(ueAddr);
         if (it == m_ueInfoByAddrMap.end())
         {
             NS_LOG_WARN("unknown UE address " << ueAddr);
@@ -207,7 +207,7 @@
         NS_LOG_LOGIC("packet addressed to UE " << ueAddr);
 
         // find corresponding UeInfo address
-        std::map<Ipv6Address, Ptr<UeInfo>>::iterator it = m_ueInfoByAddrMap6.find(ueAddr);
+        auto it = m_ueInfoByAddrMap6.find(ueAddr);
         if (it == m_ueInfoByAddrMap6.end())
         {
             NS_LOG_WARN("unknown UE address " << ueAddr);
@@ -298,7 +298,7 @@
     uint16_t cellId = msg.GetUliEcgi();
     NS_LOG_DEBUG("cellId " << cellId << " IMSI " << imsi);
 
-    std::map<uint64_t, Ptr<UeInfo>>::iterator ueit = m_ueInfoByImsiMap.find(imsi);
+    auto ueit = m_ueInfoByImsiMap.find(imsi);
     NS_ASSERT_MSG(ueit != m_ueInfoByImsiMap.end(), "unknown IMSI " << imsi);
     ueit->second->SetSgwAddr(m_sgwS5Addr);
 
@@ -360,7 +360,7 @@
     uint16_t cellId = msg.GetUliEcgi();
     NS_LOG_DEBUG("cellId " << cellId << " IMSI " << imsi);
 
-    std::map<uint64_t, Ptr<UeInfo>>::iterator ueit = m_ueInfoByImsiMap.find(imsi);
+    auto ueit = m_ueInfoByImsiMap.find(imsi);
     NS_ASSERT_MSG(ueit != m_ueInfoByImsiMap.end(), "unknown IMSI " << imsi);
     ueit->second->SetSgwAddr(m_sgwS5Addr);
 
@@ -422,7 +422,7 @@
     packet->RemoveHeader(msg);
 
     uint64_t imsi = msg.GetTeid();
-    std::map<uint64_t, Ptr<UeInfo>>::iterator ueit = m_ueInfoByImsiMap.find(imsi);
+    auto ueit = m_ueInfoByImsiMap.find(imsi);
     NS_ASSERT_MSG(ueit != m_ueInfoByImsiMap.end(), "unknown IMSI " << imsi);
 
     for (auto& epsBearerId : msg.GetEpsBearerIds())
@@ -498,7 +498,7 @@
 EpcPgwApplication::SetUeAddress(uint64_t imsi, Ipv4Address ueAddr)
 {
     NS_LOG_FUNCTION(this << imsi << ueAddr);
-    std::map<uint64_t, Ptr<UeInfo>>::iterator ueit = m_ueInfoByImsiMap.find(imsi);
+    auto ueit = m_ueInfoByImsiMap.find(imsi);
     NS_ASSERT_MSG(ueit != m_ueInfoByImsiMap.end(), "unknown IMSI" << imsi);
     ueit->second->SetUeAddr(ueAddr);
     m_ueInfoByAddrMap[ueAddr] = ueit->second;
@@ -508,7 +508,7 @@
 EpcPgwApplication::SetUeAddress6(uint64_t imsi, Ipv6Address ueAddr)
 {
     NS_LOG_FUNCTION(this << imsi << ueAddr);
-    std::map<uint64_t, Ptr<UeInfo>>::iterator ueit = m_ueInfoByImsiMap.find(imsi);
+    auto ueit = m_ueInfoByImsiMap.find(imsi);
     NS_ASSERT_MSG(ueit != m_ueInfoByImsiMap.end(), "unknown IMSI " << imsi);
     m_ueInfoByAddrMap6[ueAddr] = ueit->second;
     ueit->second->SetUeAddr6(ueAddr);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/lte/model/epc-sgw-application.cc ns-3.40/src/lte/model/epc-sgw-application.cc
--- ns-3.39/src/lte/model/epc-sgw-application.cc	2023-07-05 14:23:47.905427700 -0700
+++ ns-3.40/src/lte/model/epc-sgw-application.cc	2023-09-27 13:30:37.706839300 -0700
@@ -235,7 +235,7 @@
     uint16_t cellId = msg.GetUliEcgi();
     NS_LOG_DEBUG("cellId " << cellId << " IMSI " << imsi);
 
-    std::map<uint16_t, EnbInfo>::iterator enbit = m_enbInfoByCellId.find(cellId);
+    auto enbit = m_enbInfoByCellId.find(cellId);
     NS_ASSERT_MSG(enbit != m_enbInfoByCellId.end(), "unknown CellId " << cellId);
     Ipv4Address enbAddr = enbit->second.enbAddr;
     NS_LOG_DEBUG("eNB " << enbAddr);
@@ -301,7 +301,7 @@
     uint16_t cellId = msg.GetUliEcgi();
     NS_LOG_DEBUG("cellId " << cellId << " IMSI " << imsi);
 
-    std::map<uint16_t, EnbInfo>::iterator enbit = m_enbInfoByCellId.find(cellId);
+    auto enbit = m_enbInfoByCellId.find(cellId);
     NS_ASSERT_MSG(enbit != m_enbInfoByCellId.end(), "unknown CellId " << cellId);
     Ipv4Address enbAddr = enbit->second.enbAddr;
     NS_LOG_DEBUG("eNB " << enbAddr);
@@ -321,7 +321,7 @@
         uint32_t teid = bearerContext.fteid.teid;
         Ipv4Address enbAddr = bearerContext.fteid.addr;
         NS_LOG_DEBUG("bearerId " << (uint16_t)bearerContext.epsBearerId << " TEID " << teid);
-        std::map<uint32_t, Ipv4Address>::iterator addrit = m_enbByTeidMap.find(teid);
+        auto addrit = m_enbByTeidMap.find(teid);
         NS_ASSERT_MSG(addrit != m_enbByTeidMap.end(), "unknown TEID " << teid);
         addrit->second = enbAddr;
         GtpcModifyBearerRequestMessage::BearerContextToBeModified bearerContextOut;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/lte/model/epc-tft.cc ns-3.40/src/lte/model/epc-tft.cc
--- ns-3.39/src/lte/model/epc-tft.cc	2023-07-05 14:23:47.905427700 -0700
+++ ns-3.40/src/lte/model/epc-tft.cc	2023-09-27 13:30:37.706839300 -0700
@@ -265,7 +265,7 @@
 {
     NS_LOG_FUNCTION(this << direction << remoteAddress << localAddress << std::dec << remotePort
                          << localPort << (uint16_t)typeOfService);
-    for (std::list<PacketFilter>::iterator it = m_filters.begin(); it != m_filters.end(); ++it)
+    for (auto it = m_filters.begin(); it != m_filters.end(); ++it)
     {
         if (it->Matches(direction,
                         remoteAddress,
@@ -290,7 +290,7 @@
 {
     NS_LOG_FUNCTION(this << direction << remoteAddress << localAddress << std::dec << remotePort
                          << localPort << (uint16_t)typeOfService);
-    for (std::list<PacketFilter>::iterator it = m_filters.begin(); it != m_filters.end(); ++it)
+    for (auto it = m_filters.begin(); it != m_filters.end(); ++it)
     {
         if (it->Matches(direction,
                         remoteAddress,
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/lte/model/epc-tft-classifier.cc ns-3.40/src/lte/model/epc-tft-classifier.cc
--- ns-3.39/src/lte/model/epc-tft-classifier.cc	2023-07-05 14:23:47.905427700 -0700
+++ ns-3.40/src/lte/model/epc-tft-classifier.cc	2023-09-27 13:30:37.706839300 -0700
@@ -187,9 +187,7 @@
                                 protocol,
                                 ipv4Header.GetIdentification());
 
-            std::map<std::tuple<uint32_t, uint32_t, uint8_t, uint16_t>,
-                     std::pair<uint32_t, uint32_t>>::iterator it =
-                m_classifiedIpv4Fragments.find(fragmentKey);
+            auto it = m_classifiedIpv4Fragments.find(fragmentKey);
 
             if (it != m_classifiedIpv4Fragments.end())
             {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/lte/model/epc-ue-nas.cc ns-3.40/src/lte/model/epc-ue-nas.cc
--- ns-3.39/src/lte/model/epc-ue-nas.cc	2023-07-05 14:23:47.905427700 -0700
+++ ns-3.40/src/lte/model/epc-ue-nas.cc	2023-09-27 13:30:37.706839300 -0700
@@ -206,7 +206,7 @@
     case ACTIVE: {
         uint32_t id = m_tftClassifier.Classify(packet, EpcTft::UPLINK, protocolNumber);
         NS_ASSERT((id & 0xFFFFFF00) == 0);
-        uint8_t bid = (uint8_t)(id & 0x000000FF);
+        auto bid = (uint8_t)(id & 0x000000FF);
         if (bid == 0)
         {
             return false;
@@ -295,8 +295,7 @@
     switch (m_state)
     {
     case ACTIVE:
-        for (std::list<BearerToBeActivated>::iterator it = m_bearersToBeActivatedList.begin();
-             it != m_bearersToBeActivatedList.end();
+        for (auto it = m_bearersToBeActivatedList.begin(); it != m_bearersToBeActivatedList.end();
              m_bearersToBeActivatedList.erase(it++))
         {
             DoActivateEpsBearer(it->bearer, it->tft);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/lte/model/epc-x2-header.cc ns-3.40/src/lte/model/epc-x2-header.cc
--- ns-3.39/src/lte/model/epc-x2-header.cc	2023-07-05 14:23:47.905427700 -0700
+++ ns-3.40/src/lte/model/epc-x2-header.cc	2023-09-27 13:30:37.706839300 -0700
@@ -1209,8 +1209,7 @@
         m_headerLength += 2;
         for (int k = 0; k < sz2; k++)
         {
-            EpcX2Sap::UlInterferenceOverloadIndicationItem item =
-                (EpcX2Sap::UlInterferenceOverloadIndicationItem)i.ReadU8();
+            auto item = (EpcX2Sap::UlInterferenceOverloadIndicationItem)i.ReadU8();
             cellInfoItem.ulInterferenceOverloadIndicationList.push_back(item);
         }
         m_headerLength += sz2;
